/* -*- Javascript -*- */

/* constants  */

var nbtricks = 3;

/* object */

function Series () {
  return { name: '', volumes: '' };
}

function Author (n) {
  if (typeof n == 'undefined')
    n = 1;
  var x = { name: '', series: new Array () };
  for (var i = 0; i < n; i++)
    x.series[i] = new Series ();
  return x;
}

function Db () {
  var x = new Array ();
  x[0] = new Author ();
  return x;
}

/* global variables */

var dbcomics = new Db ();

/* get event position */

var event = null;

function get_event_position (e) {
  var pos = { x: 0, y: 0 };

  /* find coordinates */
  if (e.pageX == null) {
    /* IE case */
    var d= (document.documentElement &&
            document.documentElement.scrollLeft != null) ?
      document.documentElement : document.body;
    pos.x = e.clientX + d.scrollLeft;
    pos.y = e.clientY + d.scrollTop;
  } else {
    /* all other browsers */
    pos.x = e.pageX;
    pos.y = e.pageY;
  }

  return pos;
}

/* menu functions */

var last_action = 'hide_menu';

function hide_menu () {

  /* prevent autohide */
  if (last_action == 'show_menu') {
    last_action = 'hide_menu';
    return;
  }

  /* hide and empty menu */
  var ref = document.getElementById ('menu');
  ref.style.visibility = 'hidden';
  ref.innerHTML = '';

}

function show_menu (e, type, aid, sid) {

  update_status ('', 0);

  /* function label name */
  function menu(name, type) {
    var ret;
    switch (name) {
    case 'add': ret = 'Add ' + ((type == 0) ? 'author' : 'series') + ' entry'; break;
    case 'del': ret = 'Delete ' + ((type == 0) ? 'author' : 'series') + ' entry'; break;
    }
    return ret;
  }

  /* get event position */
  var pos = get_event_position (e);

  /* update menu */
  var ref = document.getElementById ('menu');
  var buffer = '<dl>\n';
  buffer += '<dt onclick="javascript:do_menu_func(\'add_' + type + '\', ' + aid + ', ' + sid + ');">' +
    menu('add', type) + '</dt>\n';
  buffer += '<dt ';
  if ((type == 1) && (sid == -1))
    buffer +=  'class="disabled"';
  else
    buffer +=  'onclick="javascript:do_menu_func(\'del_' + type + '\', ' + aid + ', ' + sid + ');"';
  buffer += '>' + menu('del', type) + '</dt>\n';
  buffer += '</dl>\n';
  ref.innerHTML = buffer;

  /* move and show menu */
  ref.style.left = pos.x + 'px';
  ref.style.top  = pos.y + 'px';
  ref.style.visibility = 'visible';

  last_action = 'show_menu';
}

/* add author */

function add_author (aid) {

  var ref = document.getElementById ('database');

  /* add table */

  var table = document.createElement('table');
  table.className = 'table';
  table.id = 'author_' + aid;
  ref.appendChild (table);

  /* author row */

  var row_author = table.insertRow(table.rows.length);

  /* author label */
  var cell_author_label = row_author.insertCell(0);
  cell_author_label.setAttribute ('oncontextmenu', 'javascript: show_menu(event, 0, ' + aid + ', -1);');
  cell_author_label.className = 'fit';
  var label_author = document.createElement('label');
  label_author.innerHTML = 'Author: ';
  label_author.forName = 'a_' + aid;
  cell_author_label.appendChild (label_author);

  /* author name */
  var cell_author_name = row_author.insertCell(1);
  cell_author_name.setAttribute ('oncontextmenu', 'javascript: show_menu(event, 0, ' + aid + ', -1);');
  cell_author_name.className = 'expand';
  var input_name = document.createElement('input');
  input_name.type = 'text';
  input_name.id = 'a_' + aid;
  input_name.maxLength = 255;
  input_name.value = dbcomics[aid].name;
  cell_author_name.appendChild (input_name);

  /* title row */

  var row_title = table.insertRow(table.rows.length);

  /* volume label */
  var cell_volume_label = row_title.insertCell(0);
  cell_volume_label.setAttribute ('oncontextmenu', 'javascript: show_menu(event, 1, ' + aid + ', -1);');
  var label_volume = document.createElement('label');
  label_volume.innerHTML = 'Volume(s)';
  label_volume.forName = 'v_' + aid + ':0';
  cell_volume_label.appendChild (label_volume);

  /* series label */
  var cell_series_label = row_title.insertCell(1);
  cell_series_label.setAttribute ('oncontextmenu', 'javascript: show_menu(event, 1, ' + aid + ', -1);');
  var label_series = document.createElement('label');
  label_series.innerHTML = 'Series name';
  label_series.forName = 's_' + aid + ':0';
  cell_series_label.appendChild (label_series);

  /* add all series */

  for (var sid = 0; sid < dbcomics[aid].series.length; sid++)
    if (dbcomics[aid].series[sid] != null)
      add_series (aid, sid);
}

/* add volume */

function add_series (aid, sid) {

  var table = document.getElementById ('author_' + aid);

  /* new row */

  var row = table.insertRow(table.rows.length);
  row.id = 'series_' + aid + ':' + sid;

  /* volumes */

  var cell_volumes = row.insertCell(0);
  cell_volumes.setAttribute ('oncontextmenu', 'javascript: show_menu(event, 1, ' + aid + ', ' + sid + ');');
  cell_volumes.className = 'fit';
  input_volumes = document.createElement('input');
  input_volumes.type = 'text';
  input_volumes.id = 'v_' + aid + ':' + sid;
  input_volumes.maxLength = 255;
  input_volumes.value = dbcomics[aid].series[sid].volumes;
  cell_volumes.appendChild (input_volumes);

  /* series name */

  var cell_series = row.insertCell(1);
  cell_series.setAttribute ('oncontextmenu', 'javascript: show_menu(event, 1, ' + aid + ', ' + sid + ');');
  cell_series.className = 'expand';
  var input_series = document.createElement('input');
  input_series.type = 'text';
  input_series.id = 's_' + aid + ':' + sid;
  input_series.maxLength = 255;
  input_series.value = dbcomics[aid].series[sid].name;
  cell_series.appendChild (input_series);

}

/* menu action */

function do_menu_func (func, aid, sid) {

  var message = '';
  var stat = 0;

  switch (func) {
  case 'add_0':

    aid = dbcomics.length;
    dbcomics[aid] = new Author ();

    add_author (aid);

    message = 'adding new author\'s collection';

    break;

  case 'add_1':

    sid = dbcomics[aid].series.length;
    dbcomics[aid].series[sid] = new Series ();

    add_series (aid, sid);

    message = 'adding new volume for author "' + document.getElementById ('a_' + aid).value + '"';

    break;

  case 'del_0':

    var len = dbcomics.length;
    for (var i = len; i > 0; i--)
      if (dbcomics[i - 1] == null)
        len--;

    var ref_author = document.getElementById ('author_' + aid);
    if ((len > 1) && (ref_author != null)) {
      delete dbcomics[aid];
      ref_author.parentNode.removeChild(ref_author);

      message = 'removing author\'s series';

    } else {

      message = 'can\'t remove last author\'s series';
      stat = 1;

    }

    break;

  case 'del_1':
    var len = dbcomics[aid].series.length;
    for (var i = len; i > 0; i--)
      if (dbcomics[aid].series[i - 1] == null)
        len--;

    var ref_volume = document.getElementById ('series_' + aid + ':' + sid);
    if ((len > 1) && (ref_volume != null)) {
      delete dbcomics[aid].series[sid];
      ref_volume.parentNode.removeChild(ref_volume);

      message = 'removing volume from author "' + document.getElementById ('a_' + aid).value + '"';

    } else {

      message = 'can\'t remove last volume from author "' + document.getElementById ('a_' + aid).value + '"';
      stat = 1;

    }

    break;
  }

  /* hide menu and update statut */
  hide_menu;
  update_status (message, stat);

}


/* create XML HTML Request object */

function create_xhr_object () {
  if (window.XMLHttpRequest)
    return new XMLHttpRequest ();

  if (window.ActiveXObject) {
    var names = ['Msxml2.XMLHTTP.6.0', 'Msxml2.XMLHTTP.3.0',
                 'Msxml2.XMLHTTP', 'Microsoft.XMLHTTP'];
    for (var i in names) {
      try{
        return new ActiveXObject (names[i]);
      }
      catch (err) {
      }
    }
    window.alert ('your browser does not handle XMLHTTPRequest object.');
  }
  return null;
}

/* refresh */

function refresh () {

  update_status ('', 0);

  /* clean export textarea */
  var ref = document.getElementById ('export_text');
  if (ref) ref.value = '';

  /* new tricks */
  for (var i = 0; i < nbtricks; i++) {
    var trick = document.getElementById ('trick-' + (i + 1));
    if (trick)
      trick.style.display = 'none';
  }
  var trick = document.getElementById ('trick-' + Math.floor ((Math.random () * nbtricks) + 1));
  if (trick)
    trick.style.display = 'block';
}

/* status function */

function update_status (message, stat, incr) {

  if (message == null) message = '';
  message = message.replace (/\n*$/, '');

  var classname = 'empty';
  if (message.length > 0) {
    if (stat == -1) classname = 'server';
    else if (stat == 0) classname = 'message';
    else if (stat == 1) classname = 'warning';
    else classname = 'error';
  }

  var status = document.getElementById ('status');

  status.className = classname;

  if (!incr)
    status.innerHTML = '';
  status.innerHTML += '<p>' + message.replace (/\n/g, '</p>\n<p>') + '</p>';

}

/* menu action */

function show_tab (func, arg1) {

  var list_of_pages = new Array('import', 'database', 'export');

  for (var i in list_of_pages) {

    var page = document.getElementById ('page_' + list_of_pages[i]);
    page.style.display = 'none';

  }

  var page = document.getElementById ('page_' + func);
  page.style.display = 'block';

  //var message = menu_callbacks['cb_' + func](arg1);
  var message = '';

  update_status (message, (message.length > 0) ? 1 : 0);
}


/* import texinc */

function import_texinc (data) {

  var a = 0, s = 0;

  /* get last ids */
  var aid = dbcomics.length - 1;
  var sid = dbcomics[aid].series.length - 1;

  /* hide last entry if empty */
  if (dbcomics[aid].name.length == 0) {
    var ref_author = document.getElementById ('author_' + aid);
    ref_author.parentNode.removeChild(ref_author);
  }

  /* process line by line */
  var tab = data.split ('\n');
  for (var i in tab) {

    /* process author line */
    if (tab[i].match(/^% /)) {

      /* avoid process if author name is empty */
      var author = tab[i].replace(/^%  */, '');
      if (author.length == 0)
        continue;

      if (dbcomics[aid].name.length != 0) {

        /* display previous entry */
        if (a!= 0)
          add_author (aid);

        aid++;

      }

      /* new author */
      dbcomics[aid] = new Author();
      sid = 0;

      dbcomics[aid].name = author;

      a++;

    } else if (tab[i].match (/^[^%].* &  *[^ ]/)) {
      /* process series line */

      /* avoid process if series name and volumes are empty */
      var series = tab[i]. replace(/ *\\\\$/, '').replace (/  *&  */, '|').split ('|');
      if ((series.length != 2) || ((series[0].length == 0) && (series[1].length == 0)))
        continue;

      /* new entry */
      if ((dbcomics[aid].series[sid].name.length != 0) ||
          (dbcomics[aid].series[sid].volumes.length != 0))
        dbcomics[aid].series[++sid] = new Series ();

      dbcomics[aid].series[sid].name = series[0];
      dbcomics[aid].series[sid].volumes = series[1];

      s++;

    }
  }

  /* dispay last entry */
  add_author (aid);

  return 'imported ' + a + ' authors and ' + s + ' series';
}

/* import tex */

function import_tex (data) {

  var a = 0, s = 0;

  /* get last ids */
  var aid = dbcomics.length - 1;
  var sid = dbcomics[aid].series.length - 1;

  /* hide last entry if empty */
  if (dbcomics[aid].name.length == 0) {
    var ref_author = document.getElementById ('author_' + aid);
    ref_author.parentNode.removeChild (ref_author);
  }

  /* process line by line */
  var tab = data.split ('\n');
  for (var i in tab) {

    /* process author line */
    if (tab[i].match (/^\\sec .*;$/)) {

      /* avoid process if author name is empty */
      var author = tab[i].replace (/\\sec  */, '').replace (/ *;/, '');
      if (author.length == 0)
        continue;

      /* avoid process if header line */
      if (author.match (/^\\bbit /))
          continue;

      if (dbcomics[aid].name.length != 0) {

        /* display previous entry */
        if (a!= 0)
          add_author (aid);

        aid++;

      }

      /* new author */
      dbcomics[aid] = new Author ();
      sid = 0;

      dbcomics[aid].name = author;

      a++;

    } else if (tab[i].match (/.* & .*\\cr$/)) {
      /* process series line */

      /* avoid process if series name and volumes are empty */
      var series = tab[i].replace (/ *\\cr$/, '').replace (/  *&  */, '|').split ('|');
      if ((series.length != 2) || ((series[0].length == 0) && (series[1].length == 0)))
        continue;

      /* avoid process if header line */
      if ((series[0].match (/^\\it /)) || (series[1].match (/^\\it /)))
          continue;

      /* new entry */
      if ((dbcomics[aid].series[sid].name.length != 0) ||
          (dbcomics[aid].series[sid].volumes.length != 0))
        dbcomics[aid].series[++sid] = new Series ();

      dbcomics[aid].series[sid].name = series[0];
      dbcomics[aid].series[sid].volumes = series[1];

      s++;

    }
  }

  /* dispay last entry */
  add_author (aid);

  return 'imported ' + a + ' authors and ' + s + ' series';
}

/* import csv */

function import_csv (data) {

  var a = 0, s = 0;

  /* get last ids */
  var aid = dbcomics.length - 1;
  var sid = dbcomics[aid].series.length - 1;

  /* hide last entry if empty */
  if (dbcomics[aid].name.length == 0) {
    var ref_author = document.getElementById ('author_' + aid);
    ref_author.parentNode.removeChild(ref_author);
  }

  /* process line by line */
  var tab = data.split ('\n');
  for (var i in tab) {

    /* avoid process if wrong format or header line */
    var d = tab[i].split(';');
    if ((d.length != 3) || (d[0] == 'Author'))
      continue;

    /* same author, new series */
    if ((d[0].length == 0) || (d[0] == dbcomics[aid].name)) {
      dbcomics[aid].series[++sid] = new Series ();

      dbcomics[aid].series[sid].name = d[1];
      dbcomics[aid].series[sid].volumes = d[2];

      s++;

    } else {
      /* new author and series */

      if (dbcomics[aid].name.length != 0) {

        /* display previous entry */
        if (a != 0)
          add_author (aid);

        dbcomics[++aid] = new Author();
        sid = 0;

      }

      dbcomics[aid].name = d[0];
      dbcomics[aid].series[sid].name = d[1];
      dbcomics[aid].series[sid].volumes = d[2];

      a++;
      s++;

    }

  }

  /* display last entry */
  add_author (aid);

  return 'imported ' + a + ' authors and ' + s + ' series';
}

/* import process */

function import_proc (data, type) {

  var message = '';

  switch(type) {
  case 'texinc':

    message = import_texinc (data);

    break;

  case 'tex':

    message = import_tex (data);

    break;

  case 'csv':

    message = import_csv (data);

    break;

  }

  /* clean export textarea */
  var ref = document.getElementById ('export_text');
  if (ref) ref.value = '';

  update_status (message, 0);

}

/* import file */

function import_file (type) {

  /* get file name */
  var files = document.getElementById ('import_name').files;
  if (!files.length) {
    update_status ('please select a file!', 1);
    return;
  }

  /* get encoding */
  var select_encoding = document.getElementById ('import_encoding');
  var encoding = select_encoding.options[select_encoding.options.selectedIndex].value;

  /* read file */
  var file = files[0];
  var reader = new FileReader();
  reader.onload = function(e) { import_proc (e.target.result, type); };
  reader.onerror = function(e) { update_status ('can\'t read file (' + e.target.error.code + ')', 1); };
  reader.readAsText(file);

  update_status ('file "' + file.name + '" loading', 0);
}

/* get localize strings */

function get_localize_string (ref, lang) {

  var date = new Date();

  var str = '';

  switch (lang) {

  case 'de':
    break;

  case 'fr':

    switch (ref) {
    case 'authors': str = 'Auteur(s)'; break;
    case 'database': str = 'Base de donn\\\'ees de bandes-dessin\\\'ees'; break;
    case 'date': str =  date.getDate () + '/' + (date.getMonth () + 1) + '/' + date.getFullYear (); break;
    case 'footer': str = 'Cr\\\'e\\\'ee avec \\TeX{} le @@DATE@@.'; break;
    case 'series': str = 'S\\\'eries'; break;
    case 'title': str = 'Collection de @@NBVOLUMES@@ tomes.'; break;
    case 'volumes': str = 'Tomes'; break;
    }
    break;

  case 'sp':
    break;

  case 'en':
  default:

    switch (ref) {
    case 'authors': str = 'Author(s)'; break;
    case 'database': str = 'Comics database'; break;
    case 'date': str =  (date.getMonth () + 1) + '/' + date.getDate () + '/' + date.getFullYear (); break;
    case 'footer': str = 'Created by \\TeX{} on @@DATE@@.'; break;
    case 'series': str = 'Series'; break;
    case 'title': str = 'Collection of @@NBVOLUMES@@ volumes.'; break;
    case 'volumes': str = 'Volumes'; break;
    }
    break;
  }

  return str;
}

/* export texinc */

function export_texinc (lang, encoding) {

  /* header */

  var buffer = '%% ' + get_localize_string ('database', lang) + '\n\n';

  /* body */

  for (var aid = 0; aid < dbcomics.length; aid++) {
    if (dbcomics[aid] == null)
      continue;
    buffer += '% ' + dbcomics[aid].name + '\n';
    for (var sid = 0; sid < dbcomics[aid].series.length; sid++) {
      if (dbcomics[aid].series[sid] == null)
        continue;
      buffer += dbcomics[aid].series[sid].name + ' & ' + dbcomics[aid].series[sid].volumes + ' \\\\\n';
    }
    buffer += '\n';
  }

  return buffer;
}

/* count volume number */
function count_volumes () {

  var nb = 0;
  for (var aid = 0; aid < dbcomics.length; aid++) {
    if (dbcomics[aid] == null)
      continue;

    for (var sid = 0; sid < dbcomics[aid].series.length; sid++) {
      if (dbcomics[aid].series[sid] == null)
        continue;

      var part = dbcomics[aid].series[sid].volumes.split (",");
      if (part.length == 0) {
        if (dbcomics[aid].series[sid].name.length > 0)
          nb++;
        continue;
      }

      for (var i = 0; i < part.length; i++) {

        var t = part[i].split ("-");

        switch (t.length){
        case 1:
          nb++;
          break;

        case 2:
          var b = parseInt (t[0]);
          var e = parseInt (t[1]);
          if ((!isNaN (b)) && (!isNaN (e)))
            nb += e - b + 1;
          break;

        default:
          /* error */
        }
      }
    }
  }

  return nb;
}

/* export tex */

function export_tex (lang, encoding) {

  /* texinc */

  var texinc = '';
  for (var aid = 0; aid < dbcomics.length; aid++) {
    if (dbcomics[aid] == null)
      continue;
    texinc += '\\sec ' + dbcomics[aid].name + ';\n';
    for (var sid = 0; sid < dbcomics[aid].series.length; sid++) {
      if (dbcomics[aid].series[sid] == null)
        continue;
      texinc += dbcomics[aid].series[sid].name + ' & ' + dbcomics[aid].series[sid].volumes + '\\cr\n';
    }
    texinc += '\\endsec\n\n';
  }

  /* data */

  var nbvolumes = count_volumes ();

  /* buffer */

  var buffer = texmaster ().replace (/@@TEXINC@@/, texinc);
  buffer = buffer.replace (/@@TITLE@@/, get_localize_string ('title', lang).replace (/@@NBVOLUMES@@/,  nbvolumes));
  buffer = buffer.replace(/@@AUTHORS@@/, get_localize_string ('authors', lang));
  buffer = buffer.replace(/@@SERIES@@/, get_localize_string ('series', lang));
  buffer = buffer.replace(/@@VOLUMES@@/, get_localize_string ('volumes', lang));
  buffer = buffer.replace(/@@FOOTER@@/, get_localize_string ('footer', lang).replace (/@@DATE@@/, get_localize_string ('date', lang)));

  return buffer;
}

/* export csv */

function export_csv (lang, encoding) {

  /* header */

  var buffer = get_localize_string ('authors', lang) + ';' +
    get_localize_string ('series', lang) + ';' +
    get_localize_string ('volumes', lang) + '\n';

  /* body */

  for (var aid = 0; aid < dbcomics.length; aid++) {
    if (dbcomics[aid] == null)
      continue;
    buffer += dbcomics[aid].name;
    for (var sid = 0; sid < dbcomics[aid].series.length; sid++) {
      if (dbcomics[aid].series[sid] == null)
        continue;
      buffer += ';' + dbcomics[aid].series[sid].name + ';' + dbcomics[aid].series[sid].volumes + '\n';
    }
  }

  return buffer;
}

/* export pdf */

function export_pdf (lang, encoding) {

  var texdata = export_tex (lang, encoding);

  var xhr = create_xhr_object ();

  xhr.onreadystatechange = function() {

    if ((xhr.readyState == 4) && (xhr.status == 200) && (xhr.responseXML != null)) {

      try {
        var message = xhr.responseXML.documentElement.getElementsByTagName ('message')[0];
        var pdfdata = message.getElementsByTagName ('data')[0].firstChild.nodeValue;
        var stat = message.getElementsByTagName ('stat')[0].firstChild.nodeValue;
        if (stat == 0) {
          window.location.href = 'data:application/pdf;filename=dbcomics.pdf;base64,' + pdfdata;
          update_status ('export \'pdf\' successfully completed', 0);
        } else {
          update_status ('error while generating pdf (' + stat + ')', 2);
        }
      }
      catch (err) {
        update_status ('can\'t understand server answer \'' + err + '\'', -1);
      }

    } else if (xhr.readyState == 4)
      update_status ('network error while generating pdf', -1);
  }

  var params = 'data=' + escape(texdata);

  xhr.open ('POST', 'func.php', true);

  xhr.setRequestHeader ('Content-type', 'application/x-www-form-urlencoded');
  xhr.setRequestHeader ('Content-length', params.length);
  xhr.setRequestHeader ('Connection', 'close');

  xhr.send (params);

  return '';
}

/* export process */

function export_proc (type, lang, encoding) {

  var buffer = '';

  /* retrieve data from form */
  for (var aid = 0; aid < dbcomics.length; aid++) {

    /* get author name from form */
    var ref_author = document.getElementById ('a_' + aid);

    /* clean deleted author antruy */
    if (ref_author == null) {
      delete dbcomics[aid];
      continue;
    }

    /* create a new author without any series */
    dbcomics[aid].name = ref_author.value;

    for (var sid = 0; sid < dbcomics[aid].series.length; sid++) {

      /* get series name and volume ids from form */
      var ref_series = document.getElementById ('s_' + aid + ':' + sid);
      var ref_volumes = document.getElementById ('v_' + aid + ':' + sid);

      /* clean deleted series antruy */
      if ((ref_series == null) && (ref_volumes == null)) {
        delete dbcomics[aid].series[sid];
        continue;
      }

      /* create a new series */
      if (ref_series != null)
        dbcomics[aid].series[sid].name = ref_series.value;
      if (ref_volumes != null)
        dbcomics[aid].series[sid].volumes = ref_volumes.value;

    }
  }

  /* specific processing */
  switch (type) {
  case 'texinc':
    buffer += export_texinc (lang, encoding);
    break;

  case 'tex':
    buffer += export_tex (lang, encoding);
    break;

  case 'csv':
    buffer += export_csv (lang, encoding);
    break;

  case 'pdf':
    buffer += export_pdf (lang, encoding);
    break;
  }

  return buffer;
}

/* export file */

function export_file (type) {

  /* update status */
  update_status ('export to "' + type + '" file', 1);

  /* get encoding */
  var select_encoding = document.getElementById ('export_encoding');
  var encoding = select_encoding.options[select_encoding.options.selectedIndex].value;

  /* get language */
  var select_lang = document.getElementById ('export_lang');
  var lang = select_lang.options[select_lang.options.selectedIndex].value;

  var buffer = export_proc (type, lang, encoding);

  /* display output for debugging */
  var ref = document.getElementById ('export_text');
  if (ref) ref.value = buffer;

  /* get file name */
  var filename = 'dbcomics.' + type;

  /* start download process */
  var filetype = '';
  switch (type) {
  case 'texinc':
  case 'tex':
    filetype = 'text/tex';
    break;
  case 'csv':
    filetype = 'application/csv';
    break;
  case 'pdf':
    return;
    break;
  default:
    filetytpe = 'text';
  }
  window.location.href = 'data:' + filetype + ';filename=' + filename + ';charset=' + encoding + ',' + encodeURIComponent(buffer, encoding);

  /* update status */
  update_status ('export \'' + type + '\' successfully completed', 0);

}
